Bug 49445 - After session ID is changed on authentication, the session replication does not work.
After session ID is changed on authentication, the session replication does n...
Product: Tomcat 5
Classification: Unclassified
Component: Catalina:Cluster
All All
: P2 normal (vote)
: ---
Assigned To: Tomcat Developers Mailing List
Depends on:
  Show dependency tree
Reported: 2010-06-16 05:08 UTC by Keiichi Fujino
Modified: 2010-06-28 03:44 UTC (History)
0 users

I made a patch. (12.53 KB, text/plain)
2010-06-16 06:53 UTC, Keiichi Fujino

Note You need to log in before you can comment on or make changes to this bug.
Description Keiichi Fujino 2010-06-16 05:08:02 UTC
After r889716, 
session ID is changed on authentication. 
(default of changeSessionIdOnAuthentication is true. )
But DeltaManager doesn't notify other cluster nodes. 

Therefore, non-primary node keeps having old session ID. 
And, can not replicate of change of session attribute notified by new session ID. 

The workaround is ...
override changeSessionId method, and notify to change session ID.

BackupManager is OK. 
This problem is DeltaManager only.

Best regards.
Comment 1 Keiichi Fujino 2010-06-16 06:53:58 UTC
Created attachment 25596 [details]
I made a patch.
Comment 2 Keiichi Fujino 2010-06-16 07:12:47 UTC
Fixed in trunk and proposed for 6.0.x and 5.5.x.
Comment 3 Mark Thomas 2010-06-19 10:24:32 UTC
Since this is fixed in 7.0.x (it will be included in 7.0.1 onwards) move this issue to 6.0.x
Comment 4 Keiichi Fujino 2010-06-22 06:14:53 UTC
This fix applied to 6.0, will be in 6.0.28 onwards.
Comment 5 Keiichi Fujino 2010-06-28 03:44:57 UTC
This fix applied to 5.5, will be in 5.5.30 onwards.